## swarmkit 1.12.0+git20170111.763.296fcfcf

=== Makefile ===
# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
DESTDIR=/usr/local

# Used to populate version variable in main package.
VERSION=$(shell git describe --match 'v[0-9]*' --dirty='.m' --always)

PROJECT_ROOT=github.com/docker/swarmkit

# Project packages.
PACKAGES=$(shell go list ./... | grep -v /vendor/)
INTEGRATION_PACKAGE=${PROJECT_ROOT}/integration

# Project binaries.
COMMANDS=swarmd swarmctl swarm-bench protoc-gen-gogoswarm
BINARIES=$(addprefix bin/,$(COMMANDS))

GO_LDFLAGS=-ldflags "-X `go list ./version`.Version=$(VERSION)"

.PHONY: clean all AUTHORS fmt vet lint build binaries test integration setup generate checkprotos coverage ci check help install uninstall
.DEFAULT: default

all: check binaries test integration ## run fmt, vet, lint, build the binaries and run the tests

check: fmt vet lint ineffassign ## run fmt, vet, lint, ineffassign

ci: check binaries checkprotos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

setup: ## install dependencies
	@echo "🐳 $@"
	# TODO(stevvooe): Install these from the vendor directory
	@go get -u github.com/golang/lint/golint
	#@go get -u github.com/kisielk/errcheck
	@go get -u github.com/golang/mock/mockgen
	@go get -u github.com/gordonklaus/ineffassign

generate: bin/protoc-gen-gogoswarm ## generate protobuf
	@echo "🐳 $@"
	@PATH=${ROOTDIR}/bin:${PATH} go generate -x ${PACKAGES}

checkprotos: generate ## check if protobufs needs to be generated again
	@echo "🐳 $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "👹 please run 'make generate' when making changes to proto files" && false))

# Depends on binaries because vet will silently fail if it can't load compiled
# imports
vet: binaries ## run go vet
	@echo "🐳 $@"
	@test -z "$$(go vet ${PACKAGES} 2>&1 | grep -v 'constant [0-9]* not a string in call to Errorf' | egrep -v '(timestamp_test.go|duration_test.go|exit status 1)' | tee /dev/stderr)"

fmt: ## run go fmt
	@echo "🐳 $@"
	@test -z "$$(gofmt -s -l . | grep -v vendor/ | grep -v ".pb.go$$" | tee /dev/stderr)" || \
		(echo "👹 please format Go code with 'gofmt -s -w'" && false)
	@test -z "$$(find . -path ./vendor -prune -o ! -name timestamp.proto ! -name duration.proto -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "👹 please indent proto files with tabs only" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "id = " {} \; | grep -v gogoproto.customname | tee /dev/stderr)" || \
		(echo "👹 id fields in proto files must have a gogoproto.customname set" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "Meta meta = " {} \; | grep -v '(gogoproto.nullable) = false' | tee /dev/stderr)" || \
		(echo "👹 meta fields in proto files must have option (gogoproto.nullable) = false" && false)

lint: ## run go lint
	@echo "🐳 $@"
	@test -z "$$(golint ./... | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

ineffassign: ## run ineffassign
	@echo "🐳 $@"
	@test -z "$$(ineffassign . | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

#errcheck: ## run go errcheck
#	@echo "🐳 $@"
#	@test -z "$$(errcheck ./... | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

build: ## build the go packages
	@echo "🐳 $@"
	@go build -i -tags "${DOCKER_BUILDTAGS}" -v ${GO_LDFLAGS} ${GO_GCFLAGS} ${PACKAGES}

test: ## run tests, except integration tests
	@echo "🐳 $@"
	@go test -parallel 8 -race -tags "${DOCKER_BUILDTAGS}" $(filter-out ${INTEGRATION_PACKAGE},${PACKAGES})

integration: ## run integration tests
	@echo "🐳 $@"
	@go test -parallel 8 -race -tags "${DOCKER_BUILDTAGS}" ${INTEGRATION_PACKAGE}

FORCE:

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	@test $$(go list) = "${PROJECT_ROOT}" || \
		(echo "👹 Please correctly set up your Go build environment. This project must be located at <GOPATH>/src/${PROJECT_ROOT}" && false)
	@echo "🐳 $@"
	@go build -i -tags "${DOCKER_BUILDTAGS}" -o $@ ${GO_LDFLAGS}  ${GO_GCFLAGS} ./$<

binaries: $(BINARIES) ## build binaries
	@echo "🐳 $@"

clean: ## clean up binaries
	@echo "🐳 $@"
	@rm -f $(BINARIES)

install: $(BINARIES) ## install binaries
	@echo "🐳 $@"
	@mkdir -p $(DESTDIR)/bin
	@install $(BINARIES) $(DESTDIR)/bin

uninstall:
	@echo "🐳 $@"
	@rm -f $(addprefix $(DESTDIR)/bin/,$(notdir $(BINARIES)))

coverage: ## generate coverprofiles from the unit tests
	@echo "🐳 $@"
	@( for pkg in $(filter-out ${INTEGRATION_PACKAGE},${PACKAGES}); do \
		go test -i -race -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../$$pkg/coverage.txt" -covermode=atomic $$pkg || exit; \
		go test -race -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../$$pkg/coverage.txt" -covermode=atomic $$pkg || exit; \
	done )

coverage-integration: ## generate coverprofiles from the integration tests
	@echo "🐳 $@"
	go test -race -tags "${DOCKER_BUILDTAGS}" -test.short -coverprofile="../../../${INTEGRATION_PACKAGE}/coverage.txt" -covermode=atomic ${INTEGRATION_PACKAGE}

help: ## this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST) | sort

=== debian/changelog ===
swarmkit (1.12.0+git20170111.763.296fcfcf-1) unstable; urgency=medium

  * Initial release (Closes: #844678).
  * Dummy changelog entry to refresh signature on changes file.

 -- Tim Potter <tpot@hpe.com>  Mon, 30 Jan 2017 15:43:54 +1100

=== debian/control ===
Source: swarmkit
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>= 9),
               dh-golang,
               golang-github-azure-go-ansiterm-dev,
               golang-github-boltdb-bolt-dev,
               golang-github-cloudflare-cfssl-dev,
               golang-github-docker-engine-api-dev,
               golang-github-docker-go-events-dev,
               golang-github-docker-go-units-dev,
               golang-github-docker-libnetwork-dev (>= 0.8~git20161019.0.66c8446~),
               golang-github-dustin-go-humanize-dev,
               golang-github-golang-mock-dev,
               golang-github-pivotal-golang-clock-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
	       golang-golang-x-time-dev,
               golang-go, mockgen
Standards-Version: 3.9.8
Homepage: https://github.com/docker/swarmkit
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/golang-github-docker-swarmkit.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/golang-github-docker-swarmkit.git
XS-Go-Import-Path: github.com/docker/swarmkit

Package: golang-github-docker-swarmkit-dev
Architecture: all
Depends: golang-github-azure-go-ansiterm-dev,
         golang-github-boltdb-bolt-dev,
         golang-github-cloudflare-cfssl-dev,
         golang-github-docker-engine-api-dev,
         golang-github-docker-go-events-dev,
         golang-github-docker-go-units-dev,
         golang-github-docker-libnetwork-dev (>= 0.8~git20161019.0.66c8446~),
         golang-github-dustin-go-humanize-dev,
         golang-github-golang-mock-dev,
         golang-github-pivotal-golang-clock-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
	 golang-golang-x-time-dev,
         golang-go,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Toolkit for orchestrating distributed systems at any scale
 SwarmKit is a toolkit for orchestrating distributed systems at any
 scale. It includes primitives for node discovery, raft-based consensus,
 task scheduling and more.
 .
 Its main benefits are:
 .
   * Distributed: SwarmKit uses the Raft Consensus Algorithm in order to
     coordinate and does not rely on a single point of failure to perform
     decisions.
 .
   * Secure: Node communication and membership within a Swarm are secure
     out of the box. SwarmKit uses mutual TLS for node authentication,
     role authorization and transport encryption, automating both
      certificate issuance and rotation.
 .
    * Simple: SwarmKit is operationally simple and minimizes
      infrastructure dependencies. It does not need an external database to
      operate.Overview Machines running SwarmKit can be grouped together in
      order to form a Swarm, coordinating tasks with each other.
 .
 This package contains the Swarmkit development files.

Package: swarmkit
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Toolkit for orchestrating distributed systems at any scale
 SwarmKit is a toolkit for orchestrating distributed systems at any
 scale. It includes primitives for node discovery, raft-based consensus,
 task scheduling and more.
 .
 Its main benefits are:
 .
   * Distributed: SwarmKit uses the Raft Consensus Algorithm in order to
     coordinate and does not rely on a single point of failure to perform
     decisions.
 .
   * Secure: Node communication and membership within a Swarm are secure
     out of the box. SwarmKit uses mutual TLS for node authentication,
     role authorization and transport encryption, automating both
      certificate issuance and rotation.
 .
    * Simple: SwarmKit is operationally simple and minimizes
      infrastructure dependencies. It does not need an external database to
      operate.Overview Machines running SwarmKit can be grouped together in
      order to form a Swarm, coordinating tasks with each other.
 .
 This package contains the Swarmkit command-line programs.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=golang --with=golang

export GOPATH = $(shell pwd)/obj-$(DEB_BUILD_GNU_TYPE)

override_dh_auto_build:
	# Regenerate proto files for each build
	(cd obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/docker/swarmkit && \
		export PATH=$$PATH:`pwd`/bin && \
		make -f ../../../../../Makefile generate)
	# Clean up generated binary
	rm -rf obj-$(DEB_BUILD_GNU_TYPE)/src/github.com/docker/swarmkit/bin
	# Perform regular build
	dh_auto_build

override_dh_auto_test:
	-dh_auto_test

## http://wiki.debian.org/onlyjob/get-orig-source
PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.]+)}')

.PHONY: get-orig-source

get-orig-source:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --repack --compression xz --destdir=$(CURDIR) \
              --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)

=== debian/watch ===
# uscan(1) configuration file.
version=3

 https://github.com/docker/swarmkit/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

## swarmkit 1.12.0+git20170201.779.1c7f003d

=== debian/changelog ===
swarmkit (1.12.0+git20170201.779.1c7f003d-3) unstable; urgency=medium

  [ Michael Stapelberg ]
  * Fix Vcs-* tags

  [ Konstantinos Margaritis ]
  * Replace golang-go with golang-any in Build-Depends, remove golang-go from Depends

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 08 Aug 2017 17:18:24 +0300

swarmkit (1.12.0+git20170201.779.1c7f003d-1) unstable; urgency=medium

  * New upstream snapshot for Docker 1.13.1
  * Delete docker vendor patches and replace with glgh-docker-docker-dev B-D

 -- Tim Potter <tpot@hpe.com>  Wed, 24 May 2017 11:41:13 +1000

swarmkit (1.12.0+git20170111.763.296fcfcf-2) unstable; urgency=medium

  * Run wrap-and-sort.
  * Tighten B-D on golang-gogoprotobuf-dev for stretch build.
    (Closes: #858268)
  * Suppress binary-without-manpage and spelling-error-in-binary
    Lintian messages.

 -- Tim Potter <tpot@hpe.com>  Tue, 21 Mar 2017 08:10:50 +1100

=== debian/control ===
--- 
+++ 
@@ -8,22 +8,25 @@
                golang-github-azure-go-ansiterm-dev,
                golang-github-boltdb-bolt-dev,
                golang-github-cloudflare-cfssl-dev,
+               golang-github-docker-docker-dev,
                golang-github-docker-engine-api-dev,
                golang-github-docker-go-events-dev,
                golang-github-docker-go-units-dev,
-               golang-github-docker-libnetwork-dev (>= 0.8~git20161019.0.66c8446~),
+               golang-github-docker-libnetwork-dev (>= 0.8.0-dev.2+git20170202.599.45b4086~),
                golang-github-dustin-go-humanize-dev,
                golang-github-golang-mock-dev,
                golang-github-pivotal-golang-clock-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-spf13-pflag-dev,
-	       golang-golang-x-time-dev,
-               golang-go, mockgen
+               golang-any,
+               golang-gogoprotobuf-dev (>= 0.3+git20170120.144.265e960d-1~),
+               golang-golang-x-time-dev,
+               mockgen
 Standards-Version: 3.9.8
 Homepage: https://github.com/docker/swarmkit
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/golang-github-docker-swarmkit.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/golang-github-docker-swarmkit.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/swarmkit.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/swarmkit.git
 XS-Go-Import-Path: github.com/docker/swarmkit
 
 Package: golang-github-docker-swarmkit-dev
@@ -31,18 +34,18 @@
 Depends: golang-github-azure-go-ansiterm-dev,
          golang-github-boltdb-bolt-dev,
          golang-github-cloudflare-cfssl-dev,
+#         golang-github-docker-docker-dev,
          golang-github-docker-engine-api-dev,
          golang-github-docker-go-events-dev,
          golang-github-docker-go-units-dev,
-         golang-github-docker-libnetwork-dev (>= 0.8~git20161019.0.66c8446~),
+         golang-github-docker-libnetwork-dev (>= 0.8.0-dev.2+git20170202.599.45b4086~),
          golang-github-dustin-go-humanize-dev,
          golang-github-golang-mock-dev,
          golang-github-pivotal-golang-clock-dev,
          golang-github-sirupsen-logrus-dev,
          golang-github-spf13-cobra-dev,
          golang-github-spf13-pflag-dev,
-	 golang-golang-x-time-dev,
-         golang-go,
+         golang-golang-x-time-dev,
          ${misc:Depends},
          ${shlibs:Depends}
 Description: Toolkit for orchestrating distributed systems at any scale
@@ -71,8 +74,7 @@
 Package: swarmkit
 Architecture: any
 Built-Using: ${misc:Built-Using}
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Toolkit for orchestrating distributed systems at any scale
  SwarmKit is a toolkit for orchestrating distributed systems at any
  scale. It includes primitives for node discovery, raft-based consensus,
